/* HAVEGE: HArdware Volatile Entropy Gathering and Expansion
 *          
 * Copyright (C) 2006 - Andr Seznec - Olivier Rochecouste
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA  02110-1301  USA
 *
 * emails: seznec_at_irisa_dot_fr - orocheco_at_irisa_dot_fr
 * 
 */

#ifndef HAVEGE_HARDTICK_H
#define HAVEGE_HARDTICK_H

#if HAVE_CONFIG_H
#include <config.h>
#endif

/* Only GNU Compilers are supported in HAVEGE library */

#define GNUCC
#ifdef GNUCC
#define ASM __asm__ volatile
#endif

/* read the hardware tick counter value */ 

#ifdef HAVE_ISA_X86
#define HARDCLOCK(x) ASM("rdtsc":"=A"(x))
#endif

#ifdef HAVE_ISA_SPARC
#define HARDCLOCK(x) ASM("rd %%tick, %0":"=r"(x):"r"(x)) 
#endif

#ifdef HAVE_ISA_PPC
#define HARDCLOCK(x) ASM("mftb %0":"=r"(x)) /* eq. to mftb %0, 268 */
#endif

#ifdef HAVE_ISA_IA64
#define HARDCLOCK(x) ASM("mov %0=ar.itc" : "=r"(x))
#endif

#endif /* HAVEGE_HARDTICK_H */
