/* HAVEGE: HArdware Volatile Entropy Gathering and Expansion
 *          
 * Copyright (C) 2006 - Andr Seznec - Olivier Rochecouste
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA  02110-1301  USA
 *
 * emails: seznec_at_irisa_dot_fr - orocheco_at_irisa_dot_fr
 * 
 */

#include <stdio.h>

#include "hardtick.h"
#include "havegedef.h"
#include "havege.h"

/* entropy gathering phase */
void
collect_ndrand (int *RESULT, int size)
{
  int i, inter, PTtest;
  int *Pt0, *Pt1, *Pt2, *Pt3;
  
  i = 0;
  while (i < size) {
    #include "loopbody.h"
  }
}

/* HAVEGE initialization phase */
void
init_havege (int *array, int size)
{
  int i, max;
  havege_pwalk = (int*) ALIGN(&havege_walk[4096]);

  max = MININITRAND*CRYPTOSIZECOLLECT/size;
  for (i = 0; i < max; i++) {
    collect_ndrand (array, size);
  }
}

/* HAVEGE high-throughput Random Number Generator (RNG) */
int
ndrand (void)
{
  if (havege_ndpt >= NDSIZECOLLECT) {
    if (havege_ndpt >= NDSIZECOLLECTx2) {
      init_havege (havege_bigarray, NDSIZECOLLECT);     
    }
    else {
      collect_ndrand (havege_bigarray, NDSIZECOLLECT);
    }

    havege_ndpt = 0;
  }

  return havege_bigarray[havege_ndpt++];
}

/* HAVEGE RNG - tuned for cryptography purposes */
int
crypto_ndrand (void)
{
  int i;

  if (havege_crypto_ndpt >= CRYPTOSIZECOLLECT) { 
    if (havege_crypto_ndpt >= NDSIZECOLLECTx2) {
      init_havege (havege_bigarray_crypto, CRYPTOSIZECOLLECT);
    } 
    else {
      for (i = 0; i < NBSTEPHIDING; i++) {
	collect_ndrand (havege_bigarray_crypto, CRYPTOSIZECOLLECT);
      }      
    }
    
    havege_crypto_ndpt = 0;
  }
  
  return (havege_bigarray_crypto[havege_crypto_ndpt++]);
}

