#ifndef HAVEGE_DEF_H
#define HAVEGE_DEF_H

/* Macros defined at configure time */

#if HAVE_CONFIG_H 
#include <config.h>
#endif

/* ANDPT value should be automatically generated if you 
 * used the configure script included in this package.
 * 
 * Else, ANDPT value should be computed as follows:
 *
 * ANDPT+1 = 2*Dcachesize/sizeof(int) 
 */

#ifndef ADDR64 
#define ALIGN(addr) (((int) addr) & 0xfffff000)                    
#else
#define ALIGN(addr) (((long long) addr) & 0xfffffffffffff000)
#endif

#define CRYPTOSIZECOLLECT 0x040000 /* 256k (1MB int)   */
#define NDSIZECOLLECT     0x100000 /* 1M   (4MB int)   */
#define NDSIZECOLLECTx2   0x200000 /* 2x NDSIZECOLLECT */ 
#define MININITRAND       32
#define NBSTEPHIDING      32

static int havege_ndpt        = NDSIZECOLLECTx2;    
static int havege_crypto_ndpt = NDSIZECOLLECTx2;
  
static int havege_bigarray        [NDSIZECOLLECT     + 16384];       
static int havege_bigarray_crypto [CRYPTOSIZECOLLECT + 16384]; 
static int havege_walk            [ANDPT + 4097];         

static int *havege_pwalk;   
static int PT, pt, PT2, pt2; 
static int havege_hardtick = 0;

#endif /* HAVEGE_DEF_H */
